/***************************************************************************
 $RCSfile: test1.cpp,v $
                             -------------------
    cvs         : $Id: test1.cpp,v 1.18 2003/01/05 13:25:18 aquamaniac Exp $
    begin       : Mon Nov 19 2001
    copyright   : (C) 2001 by Martin Preuss
    email       : openhbci@aquamaniac.de

 ***************************************************************************
 *                                                                         *
 *   This library is free software; you can redistribute it and/or         *
 *   modify it under the terms of the GNU Lesser General Public            *
 *   License as published by the Free Software Foundation; either          *
 *   version 2.1 of the License, or (at your option) any later version.    *
 *                                                                         *
 *   This library is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU     *
 *   Lesser General Public License for more details.                       *
 *                                                                         *
 *   You should have received a copy of the GNU Lesser General Public      *
 *   License along with this library; if not, write to the Free Software   *
 *   Foundation, Inc., 59 Temple Place, Suite 330, Boston,                 *
 *   MA  02111-1307  USA                                                   *
 *                                                                         *
 ***************************************************************************/

/*
 */


#include <stdlib.h>
#include <stdio.h>

#include <openhbci.h>
#include <openhbci/mediumkeyfile.h>
#include <openhbci/deskey.h>

using namespace HBCI;


int test1() {
}

int test2(int argc, char **argv) {
    Pointer<API> api;
    Pointer<Medium> m;
    HBCI::Error err;

    if (argc<2) {
        cerr<<"Need pin!!\n";
        return 1;
    }
    try {
        api=new API();
        Hbci::setDebugLevel(1);
        m=api.ref().mediumFactory("test.medium",MediumRDHFile);
	cerr<<"Mounting medium\n";
	err=m.ref().mountMedium(0,argv[1]);
	if (!err.isOk()) {
	    cerr<<"Could not mount medium:\n"<<err.errorString()<<"\n";
	    //return 1;
        }
        /*
        cerr<<"Creating user keys.\n";
        if (!m.cast<MediumKeyfile>().ref().createUserKeys()) {
            cerr<<"Could not create keys.\n";
            return 1;
            }
            */
        cerr<<"Unmounting medium\n";
        m.ref().unmountMedium();
    }
    catch (HBCI::Error lerr) {
        cerr<<"Exception: "<<lerr.errorString()<<"\n";
    }
    return 0;
}


int test3(int argc, char **argv) {
    Pointer<API> api;
    Pointer<Medium> m;
    Pointer<Medium> mold;
    HBCI::Error err;

    /*
    if (argc<3) {
        cerr<<"Need pins (old, new)!!\n";
        return 1;
    }
    try {
        api=new API();
        Hbci::setDebugLevel(5);
        m=api.ref().mediumFactory("test.medium",MediumRDHFile);
        mold=api.ref().mediumFactory("haspa.medium",MediumRDHFileOld);

        cerr<<"Mounting medium\n";
        if (!mold.ref().mountMedium(0,argv[1])) {
            cerr<<"Could not mount medium.";
            return 1;
        }

        if (!m.cast<MediumKeyfile>().ref().createMedium(1,
                                                        mold.cast<MediumRDH>(),
                                                        argv[2])) {
            cerr<<"Could not create Medium !!\n";
            return 1;
        }

        cerr<<"Unmounting medium\n";
        mold.ref().unmountMedium();
    }
    catch (HBCI::Error lerr) {
        cerr<<"Exception: "<<lerr.errorString()<<"\n";
        }
    */
    return 0;
}


int main(int argc, char **argv) {
    int res;

    fprintf(stderr,"Started.\n");
    res=test1();
    //res=test2(argc,argv);
    //res=test3(argc,argv);
    fprintf(stderr,"Stopped.\n");
    return res;
}




